% a)

load('las11t4data.mat');
yk = y; uk = u; % muuttujien nimien muokkaus
it = round(0.9*numel(yk)); % 90% datasta estimointiin, loput validointiin

y = yk(1:it);
u = uk(1:it);
%Selittjt:
phi = [-y(2:it-1), -y(1:it-2), u(2:it-1), u(1:it-2)];
th = (phi'*phi)\(phi'*y(3:it))

eps = y(3:it) - phi*th;
%kovarianssimatriisi Cov(thetahat)
P = eps'*eps/(it - 2)*inv(phi'*phi)

%parametrien merkitsevyys:
%95% luottamusvlit
for ii = 1:4
  fprintf('theta(%d) = %2.5f +/- %2.5f\n',ii,th(ii),1.96*sqrt(P(ii,ii)))
end

fprintf('\nPoistetaan viimeinen selittj, paina jotakin nppint...\n')
pause

%POISTETAAN VIIMEINEN SELITTJ!
%Selittjt:
phi = [-y(2:it-1), -y(1:it-2), u(2:it-1)];
th = (phi'*phi)\(phi'*y(3:it))

eps = y(3:it) - phi*th;
%kovarianssimatriisi Cov(thetahat)
P = eps'*eps/(it - 1)*inv(phi'*phi)

%parametrien merkitsevyys:
for ii = 1:3
  fprintf('theta(%d) = %2.5f +/- %2.5f\n',ii,th(ii),1.96*sqrt(P(ii,ii)))
end
fprintf('\n')

%%
% b)
% Simuloidaan jljell olevalla data-aineistolla:
for ii = it+1:numel(yk)
   ypred(ii-it)=-th(1)*yk(ii-1)-th(2)*yk(ii-2)+th(3)*uk(ii-1);
end
plot(ypred,'r*')
hold on;
plot(yk(it+1:end));
legend('ennuste','data')

%%
% c)
% Piirretn jnnskohina
subplot(2,1,1)
plot(eps);
legend('eps')

% Lasketaan autokorrelaatio
[xc xclags]=xcorr(eps);
M=length(eps);
% lasketaan summan termit
corr=xc(M:end)/xc(M);
lags=1:length(corr);

% piirretn autokerrelaation kuvaaja
subplot(2,1,2)
hold on
plot(lags,1.96/sqrt(M)*ones(1,max(lags)),'--r');
plot(lags,corr,'b');
plot(lags,-1.96/sqrt(M)*ones(1,max(lags)),'--r');
hold off
legend('95% luottamusvli','autokorrelaatio')

% lasketaan testisuure viiveeseen 10 asti
khi2=it*corr(1:10)'*corr(1:10)
chi2inv(0.95,10)