function h = imp(u, y)
% h = imp(u, y)
% Jrjestelmn impulssivasteen laskeminen Wiener-Hopfin yhtlist

um = u - mean(u);
ym = y - mean(y);
N = numel(y);
maxtau = ceil(N/10);
[~, c] = cra([ym, um], maxtau, [], 0);
% c = covf([um, ym], maxtau); % komento vanhassa MATLAB-versiossa
i0 = find(c(:, 1) == 0);
ruu = c(i0:end, 3);
ruy = c(i0:end, 4);
% h = (toeplitz(ruu))\ruy;
h = ruy/ruu(1); % jos u tiedetn valkoisesksi kohinaksi
